import * as Iceform from '@modal-sh/iceform-next';
import * as React from 'react';

const NotesItemPage: Iceform.NextPage = ({
	req,
	res,
}) => {
	const body = (res.body ?? {}) as Record<string, unknown>;
	const {response, loading, ...isoformProps} = Iceform.useResponse({
		res
	});

	const [responseData, setResponseData] = React.useState<unknown>();
	React.useEffect(() => {
		// response.bodyUsed might be undefined, so we use a strict comparison
		if (response?.bodyUsed === false) {
			response?.json().then((responseData) => {
				setResponseData(responseData);
			});
		}
	}, [response]);

	return (
		<Iceform.Form
			{...isoformProps}
			method="post"
			action={`/a/notes/${req.query.noteId}`}
			clientAction={`/api/notes/${req.query.noteId}`}
		>
			<div>
				<label>
					<span>Title</span>
					<input type="text" name="title" defaultValue={body.title as string} />
				</label>
			</div>
			<div>
				<label>
					<span>Image</span>
					<input type="file" name="image" />
				</label>
			</div>
			<div>
				<label>
					<span>Content</span>
					<textarea name="content" defaultValue={body.content as string} />
				</label>
			</div>
			<div>
				<button type="submit">Submit</button>
			</div>
		</Iceform.Form>
	)
};

export const getServerSideProps = Iceform.destination.getServerSideProps();

export default NotesItemPage;
